<?php
App::uses('EvCurrencyAppModel', 'EvCurrency.Model');
App::uses('Exchange', 'EvCurrency.Lib');
/**
 * EvCurrenciesCurrency Model
 *
 */
class Currency extends EvCurrencyAppModel {

	public $useTable = 'ev_currency_currencies';

/**
 * Display field
 *
 * @var string
 */
	public $displayField = 'name';

/**
 * Validation rules
 *
 * @var array
 */
	public $validate = array(
		'name' => array(
			'notBlank' => array(
				'rule' => array('notBlank'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
	);


    /**
     * Update Rates
     *
     * Updates the exchange rates in the EvCurrency plugin table
     * @return boolean
     */
    public function updateRates()
    {
        $api = new Exchange();
        $base_currency = Configure::read('EvCurrency.base_currency');

        $currencies = $this->find('all', array(
            'conditions' => array(
                'is_active' => 1
            )
        ));
        $currency_codes = array();

        foreach ($currencies as $currency) {

            if ($currency['Currency']['name'] != $base_currency) {

                $currency_codes[] = $currency['Currency']['name'];
            }
        }

        $rates = $api->getRates($currency_codes);

        foreach ($currencies as $currency) {

            if ($currency['Currency']['name'] != $base_currency) {

                $currency['Currency']['exchange_rate'] = $rates[$currency['Currency']['name']];
                $currency['Currency']['exchange_rate_date'] = date('Y-m-d G:i:s');
                $this->save($currency['Currency']);
            }
        }

        return;
    }
}
